# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class DscNodeConfiguration(pulumi.CustomResource):
    """
    Manages a Automation DSC Node Configuration.
    """
    def __init__(__self__, __name__, __opts__=None, automation_account_name=None, content_embedded=None, name=None, resource_group_name=None):
        """Create a DscNodeConfiguration resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not automation_account_name:
            raise TypeError('Missing required property automation_account_name')
        elif not isinstance(automation_account_name, basestring):
            raise TypeError('Expected property automation_account_name to be a basestring')
        __self__.automation_account_name = automation_account_name
        """
        The name of the automation account in which the DSC Node Configuration is created. Changing this forces a new resource to be created.
        """
        __props__['automationAccountName'] = automation_account_name

        if not content_embedded:
            raise TypeError('Missing required property content_embedded')
        elif not isinstance(content_embedded, basestring):
            raise TypeError('Expected property content_embedded to be a basestring')
        __self__.content_embedded = content_embedded
        """
        The PowerShell DSC Node Configuration (mof content).
        """
        __props__['contentEmbedded'] = content_embedded

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        Specifies the name of the DSC Node Configuration. Changing this forces a new resource to be created.
        """
        __props__['name'] = name

        if not resource_group_name:
            raise TypeError('Missing required property resource_group_name')
        elif not isinstance(resource_group_name, basestring):
            raise TypeError('Expected property resource_group_name to be a basestring')
        __self__.resource_group_name = resource_group_name
        """
        The name of the resource group in which the DSC Node Configuration is created. Changing this forces a new resource to be created.
        """
        __props__['resourceGroupName'] = resource_group_name

        __self__.configuration_name = pulumi.runtime.UNKNOWN

        super(DscNodeConfiguration, __self__).__init__(
            'azure:automation/dscNodeConfiguration:DscNodeConfiguration',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'automationAccountName' in outs:
            self.automation_account_name = outs['automationAccountName']
        if 'configurationName' in outs:
            self.configuration_name = outs['configurationName']
        if 'contentEmbedded' in outs:
            self.content_embedded = outs['contentEmbedded']
        if 'name' in outs:
            self.name = outs['name']
        if 'resourceGroupName' in outs:
            self.resource_group_name = outs['resourceGroupName']
